﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace mook_FormSkin
{
    public partial class Form1 : Form
    {
        private string strCurImgPath; //개체에 입력된 이미지 경로

        private Image imgPlayBtn; //play 버튼 이미지 개체
        private Image imgPauseBtn; //Pause 버튼 이미지 개체
        private Image imgStopBtn; //Stop 버튼 이미지 개체
        private Image imgFileOpenBtn; //FileOpen 버튼 이미지 개체
        private Image imgSpeakerBtn; //Speaker 버튼 이미지 개체
        private Image imgCloseBtn; //Close 버튼 이미지 개체
        private Image imgMinimizeBtn; //Minimize 버튼 이미지 개체

        private bool SpeakerBarMouseDown = false;
        private bool FormMouseDown = false;
        private bool SpeakerOn = true;

        private const int SPEKAERBAR_XPOS = 128; //트랙바 Left
        private const int SPEKAERBAR_YPOS = 123; //트랙바 높이
        private const int SPEKAERBAR_WIDTH = 74; //트랙바 사이즈

        private string BackPath = @"..\..\main1"; //스킨 이미지 파일 경로
        private bool BackChange = false;

        Point ptMouseCurrentPos; // 마우스 클릭 좌표 지정
        Point ptMouseNewPos; // 이동시 마우스 좌표
        Point ptFormCurrentPos; // 폼 위치 좌표 지정
        Point ptFormNewPos; // 이동시 폼 위치 좌표
       

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            FormDisplay();
        }

        private void FormDisplay()
        {
            strCurImgPath = BackPath + @"\MainBack.jpg";
            Image imgMainBack = Image.FromFile(strCurImgPath);
            this.BackgroundImage = imgMainBack;

            strCurImgPath = BackPath + @"\SpeakerTrack.jpg";
            Image imgSpeakerTrack = Image.FromFile(strCurImgPath);
            picSpeakerTrack.Image = imgSpeakerTrack;


            strCurImgPath = BackPath + @"\Close_Normal01.jpg";
            imgCloseBtn = Image.FromFile(strCurImgPath);
            picClose.Image = imgCloseBtn;

            strCurImgPath = BackPath + @"\Minimize_Normal01.jpg";
            imgMinimizeBtn = Image.FromFile(strCurImgPath);
            picMinimize.Image = imgMinimizeBtn;

            strCurImgPath = BackPath + @"\Play_Normal01.jpg";
            imgPlayBtn = Image.FromFile(strCurImgPath);
            picPlay.Image = imgPlayBtn;

            strCurImgPath = BackPath + @"\Pause_Normal01.jpg";
            imgPauseBtn = Image.FromFile(strCurImgPath);
            picPause.Image = imgPauseBtn;

            strCurImgPath = BackPath + @"\Stop_Normal01.jpg";
            imgStopBtn = Image.FromFile(strCurImgPath);
            picStop.Image = imgStopBtn;

            strCurImgPath = BackPath + @"\FileOpen_Normal01.jpg";
            imgFileOpenBtn = Image.FromFile(strCurImgPath);
            picFileOpen.Image = imgFileOpenBtn;


            strCurImgPath = BackPath + @"\SpeakerON_Normal01.jpg";
            imgSpeakerBtn = Image.FromFile(strCurImgPath);
            picSpeaker.Image = imgSpeakerBtn;
        }

        private void picSpeakerTrack_MouseDown(object sender, MouseEventArgs e)
        {
            SpeakerBarMouseDown = true;
        }

        private void picSpeakerTrack_MouseUp(object sender, MouseEventArgs e)
        {
            SpeakerBarMouseDown = false;
        }

        private void picSpeakerTrack_MouseMove(object sender, MouseEventArgs e)
        {
            if (SpeakerBarMouseDown)
            {
                if (picSpeakerTrack.Left >= SPEKAERBAR_XPOS && picSpeakerTrack.Left <= SPEKAERBAR_XPOS + SPEKAERBAR_WIDTH)
                {
                    if (e.X > 0) picSpeakerTrack.Left = picSpeakerTrack.Left + 1;
                    else picSpeakerTrack.Left = picSpeakerTrack.Left - 1;
                    picSpeakerShow();
                }

                if (picSpeakerTrack.Left <= SPEKAERBAR_XPOS)
                {
                    picSpeakerTrack.Left = SPEKAERBAR_XPOS;

                    SpeakerOn = false;
                    strCurImgPath = BackPath + @"\SpeakerOFF_Normal01.jpg";
                    imgSpeakerBtn = Image.FromFile(strCurImgPath);
                    picSpeaker.Image = imgSpeakerBtn;
                }
                if (picSpeakerTrack.Left >= SPEKAERBAR_XPOS + SPEKAERBAR_WIDTH)
                {
                    picSpeakerTrack.Left = SPEKAERBAR_XPOS + SPEKAERBAR_WIDTH;
                    picSpeakerShow();
                }
                this.lblVolume.Text = "Volume : " + (((picSpeakerTrack.Left - 128) * 100 / SPEKAERBAR_WIDTH)).ToString() + "%";
            } 
        }

        private void picSpeakerShow()
        {
            SpeakerOn = true;
            strCurImgPath = BackPath + @"\SpeakerON_Normal01.jpg";
            imgSpeakerBtn = Image.FromFile(strCurImgPath);
            picSpeaker.Image = imgSpeakerBtn;
        }

        private void picClose_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void picMinimize_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void picMinimize_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Minimize_Down01.jpg";
            imgMinimizeBtn = Image.FromFile(strCurImgPath);
            picMinimize.Image = imgMinimizeBtn;
        }

        private void picMinimize_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\Minimize_Normal01.jpg";
            imgMinimizeBtn = Image.FromFile(strCurImgPath);
            picMinimize.Image = imgMinimizeBtn;
        }

        private void picMinimize_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Minimize_Over01.jpg";
            imgMinimizeBtn = Image.FromFile(strCurImgPath);
            picMinimize.Image = imgMinimizeBtn;
        }

        private void picClose_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Close_Down01.jpg";
            imgCloseBtn = Image.FromFile(strCurImgPath);
            picClose.Image = imgCloseBtn;
        }

        private void picClose_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\Close_Normal01.jpg";
            imgCloseBtn = Image.FromFile(strCurImgPath);
            picClose.Image = imgCloseBtn;
        }

        private void picClose_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Close_Over01.jpg";
            imgCloseBtn = Image.FromFile(strCurImgPath);
            picClose.Image = imgCloseBtn; 
        }

        private void 표준ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackPath = @"..\..\main1";
            BackChange = true;
            this.lblVolume.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(34)))), ((int)(((byte)(38)))), ((int)(((byte)(41)))));
            this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(34)))), ((int)(((byte)(38)))), ((int)(((byte)(41)))));
            Invalidate();
        }

        private void 가벼운ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackPath = @"..\..\main2";
            BackChange = true;
            this.lblVolume.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(154)))), ((int)(((byte)(52)))));
            this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(154)))), ((int)(((byte)(52)))));

            Invalidate();
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (BackChange)
            {
                FormDisplay();
                BackChange = false;
            }
        }

        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                FormMouseDown = true; // 왼쪽 마우스 클릭 체크
                ptMouseCurrentPos = Control.MousePosition; // 마우스 클릭 좌표
                ptFormCurrentPos = this.Location; // 폼의 위치 좌표
            }
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                FormMouseDown = false; // 왼쪽 마우스 클릭 해체 체크
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            if (FormMouseDown == true) // 왼쪽 마우스 클릭시
            {
                ptMouseNewPos = Control.MousePosition;
                ptFormNewPos.X = ptMouseNewPos.X - ptMouseCurrentPos.X + ptFormCurrentPos.X; //마우스 이동시 가로 좌표
                ptFormNewPos.Y = ptMouseNewPos.Y - ptMouseCurrentPos.Y + ptFormCurrentPos.Y; //마우스 이동시 세로 좌표
                this.Location = ptFormNewPos;
                ptFormCurrentPos = ptFormNewPos;
                ptMouseCurrentPos = ptMouseNewPos;
            }
        }

        private void picPlay_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Play_Down01.jpg";
            imgPlayBtn = Image.FromFile(strCurImgPath);
            picPlay.Image = imgPlayBtn;
        }

        private void picPlay_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\Play_Normal01.jpg";
            imgPlayBtn = Image.FromFile(strCurImgPath);
            picPlay.Image = imgPlayBtn;  
        }

        private void picPlay_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Play_Over01.jpg";
            imgPlayBtn = Image.FromFile(strCurImgPath);
            picPlay.Image = imgPlayBtn;   
        }

        private void picPause_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Pause_Down01.jpg";
            imgPauseBtn = Image.FromFile(strCurImgPath);
            picPause.Image = imgPauseBtn; 
        }

        private void picPause_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\Pause_Normal01.jpg";
            imgPauseBtn = Image.FromFile(strCurImgPath);
            picPause.Image = imgPauseBtn;  
        }

        private void picPause_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Pause_Over01.jpg";
            imgPauseBtn = Image.FromFile(strCurImgPath);
            picPause.Image = imgPauseBtn; 
        }

        private void picStop_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Stop_Down01.jpg";
            imgStopBtn = Image.FromFile(strCurImgPath);
            picStop.Image = imgStopBtn;  
        }

        private void picStop_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\Stop_Normal01.jpg";
            imgStopBtn = Image.FromFile(strCurImgPath);
            picStop.Image = imgStopBtn; 
        }

        private void picStop_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\Stop_Over01.jpg";
            imgStopBtn = Image.FromFile(strCurImgPath);
            picStop.Image = imgStopBtn; 
        }

        private void picFileOpen_MouseLeave(object sender, EventArgs e)
        {
            strCurImgPath = BackPath + @"\FileOpen_Normal01.jpg";
            imgFileOpenBtn = Image.FromFile(strCurImgPath);
            picFileOpen.Image = imgFileOpenBtn;
        }

        private void picFileOpen_MouseMove(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\FileOpen_Over01.jpg";
            imgFileOpenBtn = Image.FromFile(strCurImgPath);
            picFileOpen.Image = imgFileOpenBtn;
        }

        private void picFileOpen_MouseDown(object sender, MouseEventArgs e)
        {
            strCurImgPath = BackPath + @"\FileOpen_Down01.jpg";
            imgFileOpenBtn = Image.FromFile(strCurImgPath);
            picFileOpen.Image = imgFileOpenBtn;
        }

        private void picSpeaker_MouseLeave(object sender, EventArgs e)
        {
            if (SpeakerOn)
            {
                strCurImgPath = BackPath + @"\SpeakerON_Normal01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }
            else
            {
                strCurImgPath = BackPath + @"\SpeakerOFF_Normal01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }  
        }

        private void picSpeaker_MouseMove(object sender, MouseEventArgs e)
        {
            if (SpeakerOn)
            {
                strCurImgPath = BackPath + @"\SpeakerON_Over01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }
            else
            {
                strCurImgPath = BackPath + @"\SpeakerOFF_Over01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }
        }

        private void picSpeaker_MouseDown(object sender, MouseEventArgs e)
        {
            if (SpeakerOn)
            {
                SpeakerOn = false;
                strCurImgPath = BackPath + @"\SpeakerOFF_Over01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }
            else
            {
                SpeakerOn = true;
                strCurImgPath = BackPath + @"\SpeakerOn_Over01.jpg";
                imgSpeakerBtn = Image.FromFile(strCurImgPath);
                picSpeaker.Image = imgSpeakerBtn;
            }
        }
    }
}
