﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net; //WebClient 클래스 사용
using System.Xml; // XmlDocument, XmlNodeList 클래스 사용
using System.IO; //StringReader 클래스 사용

namespace mook_WebXML
{
    public partial class Form1 : Form
    {
        const string headerURL = "http://localhost/"; // 주소 저장


        public Form1()
        {
            InitializeComponent();
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            this.lvFile.Items.Clear();

            WebClient wc = new WebClient();
            string buffer = wc.DownloadString(string.Format("{0}WebXml.xml", headerURL));
            wc.Dispose();

            StringReader sr = new StringReader(buffer);
            XmlDocument doc = new XmlDocument();
            doc.Load(sr);
            sr.Close();

            XmlNodeList forecastNodes = doc.SelectNodes("xml_reply/human/human_entry");

            foreach (XmlNode node in forecastNodes)
            {
                this.lvFile.Items.Add(new ListViewItem(new String[] { GetNodeValue(node, "title") }));
            }
        }
        private string GetNodeValue(XmlNode parent, string name)
        {
            try
            {
                XmlAttribute attr = parent.SelectSingleNode(name).Attributes["name"];
                if (attr != null)
                    return attr.Value;
                return null;
            }
            catch
            {
                return null;
            }
        }
    }
}
