﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32; //Registry 클래스 사용

namespace mook_Regedit
{
    public partial class Form1 : Form
    {
        TreeNode RootNode, SubNode; // 트리 노드 개체 생성
        int delNum = 1; // 인터넷 주소와 시작프로그램 구분
        string StrAddress = "Software\\Microsoft\\Internet Explorer\\TypedURLs"; //인터넷주소 레지스트리 경로
        string StrStart = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";//시작프로그램 레지스트리 경로

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tvLoad();
        }

        private void tvLoad()
        {
            this.tvRoot.BeginUpdate();
            RootNode = new TreeNode("내 컴퓨터", 0, 0);
            this.tvRoot.Nodes.Add(RootNode);

            SubNode = new TreeNode("HKEY_CLASSES_ROOT", 1, 1);
            this.tvRoot.Nodes[0].Nodes.Add(SubNode);
            SubNode = new TreeNode("HKEY_CURRENT_USER", 1, 1);
            this.tvRoot.Nodes[0].Nodes.Add(SubNode);
            SubNode = new TreeNode("HKEY_LOCAL_MACHINE", 1, 1);
            this.tvRoot.Nodes[0].Nodes.Add(SubNode);
            SubNode = new TreeNode("HKEY_USERS", 1, 1);
            this.tvRoot.Nodes[0].Nodes.Add(SubNode);
            SubNode = new TreeNode("HKEY_CURRENT_CONFIG", 1, 1);
            this.tvRoot.Nodes[0].Nodes.Add(SubNode);

            string[] reg = null;
            reg = Registry.ClassesRoot.GetSubKeyNames();
            subtvLoad(reg, 0);
            reg = Registry.CurrentUser.GetSubKeyNames();
            subtvLoad(reg, 1);
            reg = Registry.LocalMachine.GetSubKeyNames();
            //subtvLoad(reg, 2);
            reg = Registry.Users.GetSubKeyNames();
            subtvLoad(reg, 3);
            reg = Registry.CurrentConfig.GetSubKeyNames();
            subtvLoad(reg, 4);

            this.tvRoot.EndUpdate();
            this.tvRoot.Nodes[0].Expand();
        }
        private void subtvLoad(string[] reg, int i)
        {
            int nNode;
            foreach (var str in reg)
            {
                nNode = tvRoot.Nodes[0].Nodes[i].Nodes.Add(new TreeNode(str.ToString(), 1, 1));
                if (HasSubFolder(str.ToString(), i))
                {
                    SubNode = new TreeNode("하위 레지스트리", 1, 1);
                    tvRoot.Nodes[0].Nodes[i].Nodes[nNode].Nodes.Add(SubNode);
                }
            }
        }

        private bool HasSubFolder(string strPath, int k)
        {
            if (k == 0)
            {
                if (Registry.ClassesRoot.OpenSubKey(strPath + "\\").SubKeyCount > 0)
                    return true;
                else
                    return false;
            }
            else if (k == 1)
            {
                if (Registry.CurrentUser.OpenSubKey(strPath + "\\").SubKeyCount > 0)
                    return true;
                else
                    return false;
            }
            else if (k == 2)
            {
                if (Registry.LocalMachine.OpenSubKey(strPath + "\\").SubKeyCount > 0)
                    return true;
                else
                    return false;
            }
            else if (k == 3)
            {
                if (Registry.Users.OpenSubKey(strPath + "\\").SubKeyCount > 0)
                    return true;
                else
                    return false;
            }
            else if (k == 4)
            {
                if (Registry.CurrentConfig.OpenSubKey(strPath + "\\").SubKeyCount > 0)
                    return true;
                else
                    return false;
            }
            else
            {
                return false;
            }
        }

        private void btnInternet_Click(object sender, EventArgs e)
        {
            LoadURL();
        }
        private void LoadURL()
        {
            delNum = 2;
            this.lvReg.Items.Clear();
            var R_URL = Registry.CurrentUser.OpenSubKey(StrAddress);
            foreach (var reg in R_URL.GetValueNames())
            {
                var lvt = new ListViewItem(new string[] { reg.ToString(), R_URL.GetValue(reg.ToString()).ToString() });
                this.lvReg.Items.Add(lvt);
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            StartName();
        }
        private void StartName()
        {
            delNum = 3;
            this.lvReg.Items.Clear();
            var R_Start = Registry.CurrentUser.OpenSubKey(StrStart);
            foreach (var valueName in R_Start.GetValueNames())
            {
                var lvt = new ListViewItem(new string[] { valueName.ToString(), R_Start.GetValue(valueName.ToString()).ToString() });
                this.lvReg.Items.Add(lvt);
            }
        }

        private void btnDel_Click(object sender, EventArgs e)
        {
            RegDelete();
        }

        private void RegDelete()
        {
            if (delNum != 1 && this.lvReg.SelectedItems.Count > 0)
            {
                if (delNum == 2)
                {

                    var R_URL = Registry.CurrentUser.CreateSubKey(StrAddress);
                    var i = Convert.ToInt32(this.lvReg.SelectedItems[0].SubItems[0].Text.Replace("url", ""));

                    string I_URL = null;
                    do
                    {
                        string oldval = "url" + Convert.ToString(i);
                        string newval = "url" + Convert.ToString(i + 1);
                        I_URL = Convert.ToString(R_URL.GetValue(newval));
                        if (I_URL == "")
                        {
                            R_URL.DeleteValue(oldval, true);
                            MessageBox.Show("정상적으로 레지스트리를 삭제하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            LoadURL();
                            return;
                        }
                        R_URL.SetValue(oldval, I_URL);
                        i++;
                    }
                    while (I_URL != "");
                }
                else if (delNum == 3)
                {
                    var R_Start = Registry.CurrentUser.CreateSubKey(StrStart);
                    R_Start.DeleteValue(this.lvReg.SelectedItems[0].SubItems[0].Text, true);
                    MessageBox.Show("정상적으로 레지스트리를 삭제하였습니다.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    StartName();
                }
                delNum = 1;
            }
            else
                MessageBox.Show("삭제할 레지스트리를 선택하세요.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Warning);
        }

        private void 삭제ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RegDelete(); //레지스트리 삭제 메서드 호출
        }

        private void lvReg_DoubleClick(object sender, EventArgs e)
        {
            RegModify();
        }

        private void RegModify()
        {
            if (this.lvReg.SelectedItems.Count > 0)
            {
                Form2 frm2 = new Form2();
                frm2.StartPosition = FormStartPosition.CenterParent;
                frm2.ReturnName = this.lvReg.SelectedItems[0].SubItems[0].Text;
                frm2.ReturnData = this.lvReg.SelectedItems[0].SubItems[1].Text;

                if (frm2.ShowDialog() == DialogResult.OK)
                {
                    if (delNum == 2)
                    {
                        var R_URL = Registry.CurrentUser.CreateSubKey(StrAddress);
                        R_URL.SetValue(frm2.ReturnName, frm2.ReturnData);
                        LoadURL();
                    }
                    else
                    {
                        var R_Start = Registry.CurrentUser.CreateSubKey(StrStart);
                        R_Start.SetValue(frm2.ReturnName, frm2.ReturnData);
                        StartName();
                    }
                }
            }
            else
            {
                MessageBox.Show("수정할 레지스트리를 선택하세요.", "알림", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

        private void 수정ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RegModify(); //레지스트리 수정 메서드 호출
        }
    }
}
